using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace DragonChat
{
    public class UserCollection : CollectionBase
    {

        public void Add(User user)
        {
            base.List.Add(user);
        }

        public void Add(User user, bool moderated)
        {
            user.Moderated = moderated;
            base.List.Add(user);
        }

        public void Remove(User user)
        {
            base.List.Remove(user);
        }

        public void SetModerated(bool moderated)
        {
            foreach (User u in base.List)
                u.Moderated = moderated;
        }

        public User GetbyNick(string nickname)
        {
            foreach (User u in base.List)
            {
                if (u.Nickname == nickname)
                    return u;
            }
            return null;
        }

        public User GetbyUTF8(string utf8)
        {
            foreach (User u in base.List)
            {
                if (u.ToString() == utf8)
                    return u;
            }
            return null;
        }

        public User[] GetUsers()
        {
            if (base.List.Count == 0)
                return null;
            string[] names = new string[base.List.Count];
            User[] Users = new User[base.List.Count];
            int i = 0;
            foreach (User u in base.List)
            {
                names[i] = u.ToString();
                i++;
            }
            Array.Sort(names);
            for (i = 0; i < names.Length; i++)
                Users[i] = GetbyUTF8(names[i]);
            return Users;
        }
    }
}
