﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DragonChat
{
    public partial class Setup : Form
    {
        bool fontchange = false;

        Client client = null;

        FontFamily fontfamily;
        FontStyle fstyle;

        public Setup(Client c)
        {
            InitializeComponent();
            client = c;
            FontFamily[] ff = FontFamily.Families;
            bool addfont = false;
            int sf = 0;
            for (int x = 0; x < ff.Length; x++)
            {
                addfont = false;
                if (ff[x].IsStyleAvailable(FontStyle.Regular))
                {
                    addfont = true;
                }
                if (ff[x].IsStyleAvailable(FontStyle.Bold))
                {
                    addfont = true;
                }
                if (ff[x].IsStyleAvailable(FontStyle.Italic))
                {
                    addfont = true;
                }
                if (ff[x].IsStyleAvailable(FontStyle.Bold | FontStyle.Italic))
                {
                    addfont = true;
                }
                if (addfont)
                    lstFonts.Items.Add(ff[x].Name);
                if (ff[x].Name == client.InputFont.Name)
                    sf = x;

            }


            lstStyle.SelectedIndexChanged += new EventHandler(lstStyle_SelectedIndexChanged);
            lstFonts.SelectedIndexChanged += new EventHandler(lstFonts_SelectedIndexChanged);

            for (int i = 0; i < lstFonts.Items.Count; i++)
            {
                if (lstFonts.Items[i].ToString() == client.InputFont.Name)
                    lstFonts.SelectedIndex = i;
            }

            int ss = -1;
            if (ff[sf].IsStyleAvailable(FontStyle.Regular))
            {
                ss++;
                if (client.InputFont.Style == FontStyle.Regular)
                    lstStyle.SelectedIndex = ss;
            }
            if (ff[sf].IsStyleAvailable(FontStyle.Bold))
            {
                ss++;
                if (client.InputFont.Style == FontStyle.Bold)
                    lstStyle.SelectedIndex = ss;
            }
            if (ff[sf].IsStyleAvailable(FontStyle.Italic))
            {
                ss++;
                if (client.InputFont.Style == FontStyle.Italic)
                    lstStyle.SelectedIndex = ss;
            }
            if (ff[sf].IsStyleAvailable(FontStyle.Bold | FontStyle.Italic))
            {
                ss++;
                if (client.InputFont.Style == (FontStyle.Bold | FontStyle.Italic))
                    lstStyle.SelectedIndex = ss;
            }

            fontfamily = client.InputFont.FontFamily;
            fstyle = client.InputFont.Style;
            lblExample.ForeColor = client.InputColor;
        }

        void lstFonts_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                string f = lstFonts.Items[lstFonts.SelectedIndex].ToString();
                fontfamily = new FontFamily(f);
                fontchange = true;
                lstStyle.Items.Clear();
                int i = -1;
                if (fontfamily.IsStyleAvailable(FontStyle.Regular))
                {
                    lstStyle.Items.Add("Regular");
                    i = 0;
                }
                if (fontfamily.IsStyleAvailable(FontStyle.Bold))
                {
                    lstStyle.Items.Add("Bold");
                    if (i == -1)
                        i = 1;
                }
                if (fontfamily.IsStyleAvailable(FontStyle.Italic))
                {
                    lstStyle.Items.Add("Italic");
                    if (i == -1)
                        i = 2;
                }
                if (fontfamily.IsStyleAvailable(FontStyle.Bold | FontStyle.Italic))
                {
                    lstStyle.Items.Add("Bold Italic");
                    if (i == -1)
                        i = 3;
                }
                lstStyle.SelectedIndex = 0;
                fstyle = (FontStyle)i;
                lblExample.Font = new Font(f, lblExample.Font.Size, fstyle);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            fontchange = false;
        }

        void lstStyle_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!fontchange)
            {
                string ft = lstStyle.Items[lstStyle.SelectedIndex].ToString();
                fontfamily = lblExample.Font.FontFamily;
                if (ft == "Regular")
                {
                    lblExample.Font = new Font(fontfamily, lblExample.Font.Size, FontStyle.Regular);
                    fstyle = FontStyle.Regular;
                }
                if (ft == "Bold")
                {
                    lblExample.Font = new Font(fontfamily, lblExample.Font.Size, FontStyle.Bold);
                    fstyle = FontStyle.Bold;
                }
                if (ft == "Italic")
                {
                    lblExample.Font = new Font(fontfamily, lblExample.Font.Size, FontStyle.Italic);
                    fstyle = FontStyle.Italic;
                }
                if (ft == "Bold Italic")
                {
                    lblExample.Font = new Font(fontfamily, lblExample.Font.Size, (FontStyle)3);
                    fstyle = (FontStyle)3;
                }
            }
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            string ini = Application.StartupPath + @"\DragonChat.ini";
            IniFile iFile = new IniFile(ini);
            if (!client.IsConnected)
            {
                Client.Email = rtbEmail.Text;
                iFile.WriteValue("Settings", "Email", rtbEmail.Text);
                Client.Password = txtPassword.Text;
                iFile.WriteValue("Settings", "Password", txtPassword.Text);
                Client.Nickname = rtbNickname.Text;
                iFile.WriteValue("Settings", "Nickname", rtbNickname.Text);
                Client.Channel = rtbChannel.Text;
                iFile.WriteValue("Settings", "Channel", rtbChannel.Text);
            }
            client.InputFont = new Font(fontfamily, client.GetFontSize(), fstyle);
            client.InputColor = lblExample.ForeColor;
            iFile.WriteValue("Settings", "Font", fontfamily.Name);
            iFile.WriteValue("Settings", "Bold", client.InputFont.Bold.ToString());
            iFile.WriteValue("Settings", "Italic", client.InputFont.Italic.ToString());
            iFile.WriteValue("Settings", "Color", lblExample.ForeColor.R.ToString() + "," + lblExample.ForeColor.G.ToString() + "," + lblExample.ForeColor.B.ToString());
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Setup_Load(object sender, EventArgs e)
        {
            rtbEmail.Text = Client.Email;
            txtPassword.Text = Client.Password;
            rtbNickname.Text = Client.Nickname;
            rtbChannel.Text = Client.Channel;
        }

        private void lblExample_Click(object sender, EventArgs e)
        {
            ColorDialog cd = new ColorDialog();
            if (cd.ShowDialog() != DialogResult.Cancel)
                lblExample.ForeColor = cd.Color;
        }
    }
}
